$Powerup::Type["Speed"] = 0;
$Powerup::Type[0] = "Speed";
$Powerup::Type["Jump"] = 1;
$Powerup::Type[1] = "Jump";
$Powerup::Type["Damage"] = 2;
$Powerup::Type[2] = "Damage";
$Powerup::Type["Regen"] = 3;
$Powerup::Type[3] = "Regen";
$Powerup::Type["Immune"] = 4;
$Powerup::Type[4] = "Immune";

datablock AudioProfile(SpeedPowerupSound)
{
   filename    = "./sound_speed.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(JumpPowerupSound)
{
   filename    = "./sound_jump.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(DamagePowerupSound)
{
   filename    = "./sound_damage.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(RegenPowerupSound)
{
   filename    = "./sound_regen.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(ShieldPowerupSound)
{
   filename    = "./sound_shield.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ItemData(HastePowerupItem)
{
    uiName = "Powerup - Speed Boost";
    iconName = "";
    image = PowerupImage;
    category = Weapon;
    className = Weapon;
    shapeFile = "./haste.dts";
    mass = 1;
    density = 0.2;
    elasticity = 0;
    friction = 0.6;
    scale = "1 1 1";
    emap = true;
    doColorShift = true;
    colorShiftColor = "0.5 1 0 1";
    canDrop = true;
    hasLight = true;
    lightType = "ConstantLight";
    lightColor = "0.5 1 0";
    lightTime = -1;
    lightRadius = 5;
    
    isPowerup = true;
    powerupType = "speed";
    powerupTime = 15;
    powerupValue = 1.33;

	powerupColor = "<color:80FF00>";

	powerupSound = SpeedPowerupSound;
};

datablock ShapeBaseImageData(PowerupImage)
{
   // Basic Item properties
   shapeFile = "./haste.dts";
};

datablock ItemData(QuadDamagePowerupItem : HastePowerupItem)
{
	uiName = "Powerup - Quad Damage";
	shapeFile = "./quaddamage.dts";
	colorShiftColor = "1 0.5 0 1";
	lightColor = "1 0.5 0";

	powerupType = "damage";
	powerupTime = 15;
	powerupValue = 4; 

	powerupColor = "<color:FF8000>";

	powerupSound = DamagePowerupSound;
};

datablock ItemData(DoubleDamagePowerupItem : QuadDamagePowerupItem)
{
	uiName = "Powerup - Double Damage";
	shapeFile = "./doubledamage.dts";
	colorShiftColor = "1 1 0 1";
	lightColor = "1 1 0";

	powerupType = "damage";
	powerupTime = 15;
	powerupValue = 2; 

	powerupColor = "<color:FFFF00>";

};

datablock ItemData(JumpPowerupItem : HastePowerupItem)
{
	uiName = "Powerup - High Jump";
	shapeFile = "./jump.dts";
	colorShiftColor = "0 1 1 1";
	lightColor = "0 1 1";

	powerupType = "jump";
	powerupTime = 15;
	powerupValue = 10; 

	powerupColor = "<color:00FFFF>";

	powerupSound = JumpPowerupSound;
};

datablock ItemData(RegenPowerupItem : HastePowerupItem)
{
	uiName = "Powerup - Regeneration";
	shapeFile = "./healthregen.dts";
	colorShiftColor = "1 0 0.2 1";
	lightColor = "1 0 0.2";

	powerupType = "regen";
	powerupTime = 15;
	powerupValue = 5; 
	powerupColor = "<color:FF0033>";

	powerupSound = RegenPowerupSound;
};

datablock ItemData(ImmunePowerupItem : HastePowerupItem)
{
	uiName = "Powerup - Invincibility";
	shapeFile = "./shield.dts";
	colorShiftColor = "0.5 0.5 1 1";
	lightColor = "0.5 0.5 1";

	powerupType = "immune";
	powerupTime = 10;
	powerupValue = 1; 
	powerupColor = "<color:8080FF>";

	powerupSound = ShieldPowerupSound;
};



function isPowerupType(%t)
{
    %n = $powerup::type[%t];
	if(%t !$= $Powerup::type[%n])
		return 0;
        
    return 1;
}

function Player::SpeedPowerUp(%this,%amt)
{
    if(!isObject(%this))
        return;
    %this.setMaxForwardSpeed(%this.getDatablock().maxForwardSpeed*%amt);
    %this.setMaxBackwardSpeed(%this.getDatablock().MaxBackwardSpeed*%amt);
    %this.setMaxSideSpeed(%this.getDatablock().MaxSideSpeed*%amt);
}
function Player::FixSpeed(%this,%amt)
{
    if(!isObject(%this))
        return;
    %this.setMaxForwardSpeed(%this.getDatablock().maxForwardSpeed);
    %this.setMaxBackwardSpeed(%this.getDatablock().MaxBackwardSpeed);
    %this.setMaxSideSpeed(%this.getDatablock().MaxSideSpeed);
}

function Player::regenPowerup(%this)
{
     %this.addHealth(%this.powerUpValue["regen"]);
	//announce("added" SPC %this.powerUpValue["regen"] SPC "now" SPC %this.getDatablock().maxDamage-%this.getDamageLevel());
	%this.regenPowerupLoop = %this.schedule(1000,regenPowerup);
}

function Player::addPowerup(%this,%powerup,%time,%value,%name,%color)
{
    if(!isPowerupType(%powerup))
        return;
    
    if(%time <= 0)
        %time = 0;

	%f = %powerup;
	%powerup = $Powerup::Type[%f];
    
	messageClient(%this.client,'',"\c6You picked up the " @ %color @ %name @ "\c6 Powerup, which will last \c3" @ %time @ " \c6seconds!");
    //announce("Added powerup:" SPC %powerup);
    cancel(%this.powerUpSchedule[%powerup]);
    %this.hasPowerup[%powerup] = 1;
    if(%this.powerUpValue[%powerup] < %value)
    	%this.powerUpValue[%powerup] = %value;
    %this.powerUpSchedule[%powerup] = %this.schedule(%time*1000,cancelPowerup,%powerup,%name,%color);
    
    if(%powerup $= "speed")
    {
        %this.SpeedPowerUp(%value);
    }
     if(%powerup $= "regen")
    {
	cancel(%this.regenPowerupLoop);
	%this.RegenPowerUp();
    }
     if(%powerup $= "immune")
    {
	%this.setTempColor("0.5 0.5 1 1",%time*1000);
    }
}

function Player::cancelPowerup(%this,%powerup,%name,%color)
{
    if(!isPowerupType(%powerup))
        return;
    
    if(!%this.hasPowerup[%powerup])
        return;
    
	messageClient(%this.client,'',"\c6Your " @ %color @ %name @ " \c6Powerup has worn off!");
    //announce("Removed powerup:" SPC %powerup);
    %this.hasPowerup[%powerup] = 0;
    %this.powerUpValue[%powerup] = 0;
    
    if(%powerup $= "Speed")
    {
        %this.fixSpeed();
    }
	if(%powerup $= "regen")
    {
	cancel(%this.regenPowerupLoop);
    }
}

registerOutputEvent("Player", "addPowerup", "list Speed 0 Jump 1 Damage 2 Regeneration 3 Invincibility 4" TAB "int 0 60 15" TAB "float -20 20 0.2" TAB "string 32 64", 0);
registerOutputEvent("Bot", "addPowerup", "list Speed 0 Jump 1 Damage 2 Regeneration 3 Invincibility 4" TAB "int 0 60 15" TAB "float -20 20 0.2" TAB "string 32 64", 0);

package powerup
{
  function Armor::onCollision(%this,%obj,%col,%a,%b,%c,%d,%e,%f)
  {
    if(%col.getClassName() $= "Item" && %col.canPickup)
    {
        if(%col.getDatablock().isPowerup != true || !isPowerupType(%col.getDatablock().powerupType) )
        {
            parent::onCollision(%this,%obj,%col,%a,%b,%c,%d,%e,%f);
            return;
        }
        %pu = %col.getDatablock();
        %type = $Powerup::Type[%pu.powerupType];
        %time = %pu.powerupTime;
	%sound = %pu.powerupSound;
        %value = %pu.powerupValue;
	%name = strReplace(%pu.uiName,"Powerup - ","");
	%color = %pu.powerupColor;
        %obj.addPowerup(%type,%time,%value,%name,%color);
	serverplay3d(%sound,%obj.getHackPosition() SPC "0 0 1 0");
        
        %obj.hasPowerup[%type] = 1;
        //announce(%type);
        
        if(isObject(%col.spawnBrick))
        {
          %col.fadeOut();
          %col.schedule(%col.spawnBrick.itemRespawnTime,fadein);
        }
        else
          %col.schedule(10,delete);
        
        return;
    }
    parent::onCollision(%this,%obj,%col,%a,%b,%c,%d,%e,%f);
  }
    
    function ItemData::onAdd(%this,%obj)
	{
        if(!%this.isPowerup)
        {
            parent::onAdd(%this,%obj);
            return;
        }
		%obj.schedule(5,"applyBounce");
		Parent::onAdd(%this,%obj);
	}
	function Item::applyBounce(%obj)
	{
		if(isObject(%obj.spawnBrick))
		{
			%obj.rotate = 1;
		}
	}

function Armor::Damage(%this,%obj,%sourceObject,%pos,%damage,%damageType)
    {
	%source = %sourceObject.sourceObject;
	if(%source.hasPowerup["damage"])
	{
		%damage *= %source.powerupValue["damage"];
	}
	if(%obj.hasPowerup["immune"])
	{
		%damage = 0;
	}
        parent::Damage(%this,%obj,%sourceObject,%pos,%damage,%damageType);
    }

function Armor::onTrigger(%this, %obj, %slot, %val)
	{
		if(%slot != 2 || %val == 0)
			return parent::onTrigger(%this, %obj, %slot, %val);
		if((getWord(%obj.getVelocity(),2) <= 0.05 && getWord(%obj.getVelocity(),2) >= -0.05) && %obj.hasPowerup["jump"]) {
			%obj.addVelocity("0 0" SPC %obj.powerupValue["jump"]);}
		parent::onTrigger(%this, %obj, %slot, %val);
		
	}
};
deactivatepackage(powerup);activatePackage(powerup);
